import os
import urllib

import nautilus
import gtk
import gconf

ECHO_ADD_ICON = '/usr/bin/env echo-icon-add-gtk'

class EchoAddIconExtension(nautilus.MenuProvider):
  def __init__(self):
    self.gconf = gconf.client_get_default()
  
  def _echo_add_icon(self, file):
    #strip leading file://
    filename = urllib.unquote(file.get_uri()[7:])
    
    os.system('%s \'%s\' &' % (ECHO_ADD_ICON, filename))
  
  def menu_activate_cb(self, menu, file):
    self._echo_add_icon(file)
  
  def get_file_items(self, window, files):
    if len(files) != 1:
      return
    
    file = files[0]
    if file.get_uri_scheme() != 'file':
      return

    if file.get_mime_type() != 'image/svg+xml':
      return
      
    item = nautilus.MenuItem('NautilusPython::echoaddicon_file_item',
                             'Upload Echo Icon',
                             'Uploads selected icons to fedorahosted')
    item.connect('activate', self.menu_activate_cb, file)
    return item,
  
