import os
import urllib

import nautilus
import gtk
import gconf

ECHO_NEW_ICON = '/usr/bin/env echo-icon-new-gtk'

class EchoNewIconExtension(nautilus.MenuProvider):
  def __init__(self):
    self.gconf = gconf.client_get_default()
  
  def _echo_new_icon(self, file):
    #strip leading file://
    filename = urllib.unquote(file.get_uri()[7:])
    
    os.chdir(filename)
    os.system('%s &' % ECHO_NEW_ICON)
  
  def menu_activate_cb(self, menu, file):
    self._echo_new_icon(file)
  
  def menu_background_activate_cb(self, menu, file):
    self._echo_new_icon(file)
  
  def get_file_items(self, window, files):
    if len(files) != 1:
      return
    
    file = files[0]
    if not file.is_directory() or file.get_uri_scheme() != 'file':
      return
    
    item = nautilus.MenuItem('NautilusPython::echonewicon_file_item',
                             'Create New Echo Icon',
                             'Create New Echo Icon In %s' % file.get_name())
    item.connect('activate', self.menu_activate_cb, file)
    return item,
  
  def get_background_items(self, window, file):
    item = nautilus.MenuItem('NautilusPython::echonewicon_item',
                             'Create New Echo Icon Here',
                             'Create New Echo Icon In This Directory')
    item.connect('activate', self.menu_background_activate_cb, file)
    return item,
